//Version 1.1 (2017-04-30)
//Pat Campeau

import java.util.Scanner;

public class TicTacToe 
{
	//**************************************************************
    //CUSTOMIZATION SECTION
    //**************************************************************
	
    private static int numberOfGames = 1000;
    private static String playingX = "ai";   //"human" or "ai"
    private static String playingO = "ai";   //"human" or "ai"
    private static boolean guiOutputOn = false;
	
	//**************************************************************
	//OTHER STATIC DATAFIELDS
	//**************************************************************
	
    private static String[][] b;
    private static String goesFirst = "X";
    private static String turn;
    private static int winsX = 0;
    private static int winsO = 0;
    private static int ties = 0;
    private static int gamesPlayed = 0;
	
	public static void main(String[] args)
	{
		while(gamesPlayed < numberOfGames)
		{
			turn = goesFirst;
			b = new String[3][3];
			b[0][0] = "";
			b[0][1] = "";
			b[0][2] = "";
			b[1][0] = "";
			b[1][1] = "";
			b[1][2] = "";
			b[2][0] = "";
			b[2][1] = "";
			b[2][2] = "";

			if (guiOutputOn == true)
			{	
				NOOPDraw.createWindow(617,640); //to give drawing canvas of 600x600
			}
			String winner = "";
			while(!boardIsFull() && winner.equals(""))
			{
				if (guiOutputOn == true)
				{
					drawBoard();
				}
				System.out.println(boardToString());
				int choice = getPlayerChoice();
				setChoice(choice);
				switchTurns();
				winner = checkForWin();
			}
			if (guiOutputOn == true)
			{
				drawBoard();
			}
			System.out.println(boardToString());
			if (winner.equals(""))
			{
				System.out.println("GAME OVER - TIE GAME");
				ties++;
			}
			else if (winner.equals("X"))
			{
				System.out.println("GAME OVER - X WINS!");
				winsX++;
			}
			else if (winner.equals("O"))
			{
				System.out.println("GAME OVER - O WINS!");
				winsO++;
			}
			gamesPlayed++;
		}
		System.out.println("****************************************************");
		System.out.println("RESULTS");
		System.out.println("X Wins: " + winsX);
		System.out.println("O Wins: " + winsO);
		System.out.println("Ties: " + ties);
	}
	
	private static void setChoice(int choice)
	{
		if (choice==0)
		{
			b[0][0]=turn;
		}
		else if (choice==1)
		{
			b[0][1]=turn;
		}
		else if (choice==2)
		{
			b[0][2]=turn;
		}
		else if (choice==3)
		{
			b[1][0]=turn;
		}
		else if (choice==4)
		{
			b[1][1]=turn;
		}
		else if (choice==5)
		{
			b[1][2]=turn;
		}
		else if (choice==6)
		{
			b[2][0]=turn;
		}
		else if (choice==7)
		{
			b[2][1]=turn;
		}
		else if (choice==8)
		{
			b[2][2]=turn;
		}
	}
	
	private static int getPlayerChoice()
	{
		int choice = -1;
		while (choice < 0 || choice > 8 || !spotAvailable(choice))
		{
			if (turn.equals("X") && playingX.equals("human"))
			{
				choice = getConsoleInput();
			}
			else if (turn.equals("O") && playingO.equals("human"))
			{
				choice = getConsoleInput();
			}
			else if (turn.equals("X") && playingX.equals("ai"))
			{
				choice = SuperCampeauAI.getXChoice();   //***UPDATE HERE***
			}
			else if (turn.equals("O") && playingO.equals("ai"))
			{
				choice = SuperCampeauAI.getOChoice();   //***UPDATE HERE***
			}
			else
			{
				System.out.println("ERROR ERROR ERROR");
				choice = -1;
			}
		}
		return choice;
	}
	
	private static void switchTurns()
	{
		if (turn.equals("X"))
		{
			turn = "O";
		}
		else if (turn.equals("O"))
		{
		    turn = "X";	
		}
	}
	
	private static int getConsoleInput()
	{
		
		Scanner s = new Scanner(System.in);
		int answer = -1;
		
		while(answer < 0 || answer > 8 || !spotAvailable(answer))
		{
		   System.out.println(turn + "'s turn to pick a square (0-8)");
		   answer = s.nextInt();
		}
		return answer;
	}
	
	private static void drawBoard()
	{
		NOOPDraw.drawLine(200, 0, 200, 600);
		NOOPDraw.drawLine(400, 0, 400, 600);
		NOOPDraw.drawLine(0, 200, 600, 200);
		NOOPDraw.drawLine(0, 400, 600, 400);
		NOOPDraw.setFontSize(100);
		NOOPDraw.drawString(b[0][0], 68,  130);
		NOOPDraw.drawString(b[0][1], 268, 130);
		NOOPDraw.drawString(b[0][2], 468, 130);
		NOOPDraw.drawString(b[1][0], 68,  330);
		NOOPDraw.drawString(b[1][1], 268, 330);
		NOOPDraw.drawString(b[1][2], 468, 330);
		NOOPDraw.drawString(b[2][0], 68,  530);
		NOOPDraw.drawString(b[2][1], 268, 530);
		NOOPDraw.drawString(b[2][2], 468, 530);
	}
	
	private static String boardToString()
	{
		String s0 = b[0][0].equals("") ? "-" : b[0][0];
		String s1 = b[0][1].equals("") ? "-" : b[0][1];
		String s2 = b[0][2].equals("") ? "-" : b[0][2];
		
		String s3 = b[1][0].equals("") ? "-" : b[1][0];
		String s4 = b[1][1].equals("") ? "-" : b[1][1];
		String s5 = b[1][2].equals("") ? "-" : b[1][2];

		String s6 = b[2][0].equals("") ? "-" : b[2][0];
		String s7 = b[2][1].equals("") ? "-" : b[2][1];
		String s8 = b[2][2].equals("") ? "-" : b[2][2];
		
		return s0+s1+s2+"\n"+s3+s4+s5+"\n"+s6+s7+s8+"\n";
	}
	
	private static boolean boardIsFull()
	{
		if (b[0][0]==""||b[0][1]==""||b[0][2]==""||b[1][0]==""||b[1][1]==""||b[1][2]==""||b[2][0]==""||b[2][1]==""||b[2][2]=="")
		{
		    return false;
		}
		else
		{
			return true;
		}
	}
	
	private static String checkForWin()
	{
		//top row
		if (b[0][0]==b[0][1] && b[0][0] == b[0][2] && !b[0][0].equals(""))
		{
			return b[0][0];
		}
		//middle row
		else if (b[1][0]==b[1][1] && b[1][0] == b[1][2] && !b[1][0].equals(""))
		{
			return b[1][0];
		}
		//bottom row
		else if (b[2][0]==b[2][1] && b[2][0] == b[2][2] && !b[2][0].equals(""))
		{
			return b[2][0];
		}
		//left column
		else if (b[0][0]==b[1][0] && b[0][0] == b[2][0] && !b[0][0].equals(""))
		{
			return b[0][0];
		}
		//mid column
		else if (b[0][1]==b[1][1] && b[0][1] == b[2][1] && !b[0][1].equals(""))
		{
			return b[0][1];
		}
		//right column
		else if (b[0][2]==b[1][2] && b[0][2] == b[2][2] && !b[0][2].equals(""))
		{
			return b[0][2];
		}
		//diagonal 1
		else if (b[0][0]==b[1][1] && b[0][0] == b[2][2] && !b[0][0].equals(""))
		{
			return b[0][0];
		}
		//diagonal 2
		else if (b[0][2]==b[1][1] && b[0][2] == b[2][0] && !b[0][2].equals(""))
		{
			return b[0][2];
		}
		else
		{
			return "";  //no winner
		}
	}
	
	public static boolean spotAvailable(int number)
	{
		if (getValueAt(number).equals(""))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public static String getValueAt(int number)
	{
		if (number == 0)
			return b[0][0];
		else if (number == 1)
			return b[0][1];
		else if (number == 2)
			return b[0][2];
		else if (number == 3)
			return b[1][0];
		else if (number == 4)
			return b[1][1];
		else if (number == 5)
			return b[1][2];
		else if (number == 6)
			return b[2][0];
		else if (number == 7)
			return b[2][1];
		else if (number == 8)
			return b[2][2];
		else
			return "Error";
	}
	
	public static int spotsLeft()
	{
		int count = 0;
		for (int n=0; n<=8; n++)
		{
			if (getValueAt(n).equals(""))
			{
				count++;
			}
		}
		return count;
	}
	
	public static int spotsTaken()
	{
		return 9 - spotsLeft();
	}
	
	public static String boardToStringOneLine()
	{
		String str = b[0][0]+b[0][1]+b[0][2]+b[1][0]+b[1][1]+b[1][2]+b[2][0]+b[2][1]+b[2][2];
		return str;
	}
	

}
	